
_form_data_parse() {
	response type text/plain panic
	echo _form_data_parse is deprecated. use _split_multipart instead
}

_split_multipart() LANG=C awk -vq="'" -vLF='
' 'BEGIN {
		EOL="\r?\n"; # unix or CRLF. RFC says CRLF
		CRLF="\r\n"  # strict CRLF
		ORS="";
		RS=CRLF # what is premature hardeing the root of?
		# # TODO: boundary can be regexp. does awk have \Q ?
		# getline boundary; RS=EOL""boundary"(--|"EOL")"
		getline RS
		RS=CRLF""RS
	}
	{ printf "%s", $0 | "sed -E "q"1,/^\\r$/{w"into"/d/"NR""LF"d}"q" >"into"/f/"NR }
' "$@"

response() while ! [ $# = 0 ]; do
	case "${1}"
	in (status) case "${2}"
		in (ok)   RESP_STATUS='HTTP/1.1 200 OK'
		;; (nope) RESP_STATUS='HTTP/1.1 501 Not Implemented'
		;; (*)    RESP_STATUS="HTTP/1.1 $2"
		esac; shift 2
	;; (type) case "${2}"
		in (text/*) RESP_CONTENT_TYPE="Content-Type: $2; charset=UTF-8"
		;; (*)      RESP_CONTENT_TYPE="Content-Type: $2"
		esac; shift 2
	;; (start | print ) shift; printf '%s\r\n' \
		"${RESP_STATUS:-HTTP/1.1 200 OK}" \
		"${RESP_CONTENT_TYPE:-Content-Type: text/html; charset=UTF-8}" \
		"$@" ""
		return
	;; (panic) printf '%s\r\n' \
		'HTTP/1.1 500 Internal Server Error' \
		'Content-Type: text/plain; charset=UTF-8' "$@" ""
		return
	esac
done

request() while ! [ $# = 0 ]; do
	case "${1}"
	in (posted) [ "$REQUEST_METHOD" = POST ]
	;; (data)
		shift
		$0 posted && _form_data_parse "$@"
	resp panic ; echo not expected at all "$*"
	;; (*) resp panic ; echo not expected at all "$*"
		exit 1
	esac
done

