
__xml__ nodes a \
	title header footer main nav aside article \
	div p span blockquote \
	em strong code pre kbd mark u b i  \
	dl dt dd ul ol li \
	h1 h2 h3 h4 h5 h6 h7 h8 h9 \
	table caption tr td tbody thead \
	form button field fieldset legend label select \
	figure figcaption svg \
	details summary
__xml__ leaves link input img

__html() {
	printf '<!doctype html><html'
	__xml__ @ "$@"
	printf '<head><meta charset="utf-8">'
	__body() printf '</head><body>'
	trap "printf '</body></html>'" EXIT
}

meta() {
	while ! [ $# = 0 ]; do case "${1}"
	in (@*) printf '<meta property="%s" content="%s"/>' "${1#?}" "$2" ; shift 2
	;; (:*) printf '<meta name="%s" content="%s"/>'     "${1#?}" "$2" ; shift 2
	;; (*)  >&2 echo "is $1 a :name or a @property?" ; exit 1
	esac
	done
}
