#include <stdio.h>
#include <ctype.h>

void usage(void) {puts(
"	transforme une chaine en un motif insensible à la case\n"
"	(pour sed ou case)\n"
"\n"
"	example: cic jpe?g$ LoL\n"
"	affiche:\n"
"\n"
"	[jJ][pP][eE]?[gG]$\n"
"	[lL][oO][lL]\n"
"\n"
);}

int main (int argc, char **argv) {
	if ( argc < 2 ) { usage(); return 0; }
	for (int a = 1; a < argc; ++a ) {
		for ( char * c = argv[a]; *c; ++c ) {
			if ( isalpha(*c) ) printf(
				"[%c%c]"
				, *c
				, *c ^ 32 // (1 << 5)
				);
			else putchar(*c);
		}
		putchar('\n');
	}
	return 0;
}
