#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>

// * like ls but preserving the dirname in the output.
// * like find dirname -maxdepth
// * like printf '%s\n' dirname/* but releasing ASAP
/****** DIES IRAE ****

* dir is an old, useless almost ls command
* dirs is a zsh builtin

... so direa for 'dir all entries' (but not . and .. )

TIL that d_reclen and d_type don't need stat() thanks to

	struct dirent {
		ino_t          d_ino;       // Inode number
		off_t          d_off;       // Not an offset; see below
		unsigned short d_reclen;    // Length of this record
		unsigned char  d_type;      // Type of file; not supported by all filesystem types
		char           d_name[256]; // Null-terminated filename
	}

TODO?:
	* -h for hidden
	* -f for file (avoiding fifos is important)

*/

int
main (int argc, char **argv) {

	DIR *dir;
	struct dirent *e;

	for
	( int a=1
	; a < argc
	; ++a
	) {
		if (! (dir = opendir(argv[a]))) return 1;
		ent: while ( (e = readdir(dir)) ) {
			if ( e->d_name[0] == '.' ) {
				switch ( e->d_name[1] ) {
					case  '.': if ( e->d_name[2] == '\0' ) goto ent;
					case '\0': goto ent;
				}
			}
			fputs( argv[a], stdout );
			putchar('/');
			puts( e->d_name );
		}
		closedir(dir);
	}

}
