_was_fzy_db() perl -E '
	# delete from the list
	# * older occurrences of the same name
	# * (re)moved entries
	# reverse is important to keep the most recent one
	@s = reverse grep {chomp; !$seen{$_}++ && -e} reverse <>;

	# release stdout first so the pipe can go on
	say for @s;

	# then save the deletations
	open U, ">", $ARGV;
	say  U for @s;

' "$@"

_was_fzy_ui(){tac|fzy}
was_fzy() { _was_fzy_db $1 | _was_fzy_ui }
