<<\% : Doc

version 0.0

# Examples

	. TAP.sh
	(TAP
		test -e /etc/passwd; ok we have a user base
		true               ; ok truth is truth
		false              ; ok truth is truth)

# Tips

use an harness to get nice reports

test output with prove -e sh t

%


TAP() {
	case $#
	in (0) set 'version 13'
	;; (*) ……
		case "$1"
		in (long) TAP_EXPORT=false
			shift
		;; (sh:*) ……
		esac
	esac
	${TAP_EXPORT:-true} && {
		ok() TAP_ok "$@"
	}
	echo "TAP $*"
	TAP_INDEX=0 TAP_FAILS=
	trap 'echo 1..$TAP_INDEX'  EXIT
}

TAP_ok() {
	local r=$?
	TAP_INDEX=$(( TAP_INDEX + 1 ))
	case $r
	in (0) echo     "ok $TAP_INDEX - $*"
	;; (*) echo "not ok $TAP_INDEX - $*"
		TAP_FAILS="$TAP_FAILS $TAP_INDEX"
	esac
	return $r
}
